require File.join(__dir__, '../../lib/rise/mirror_manager/configuration')
require 'sqlite3'

# require_relative File.join(__dir__, '../../config/initializers/production')
# puts 'initializing'

Rise::MirrorManager.configure do |config|
  config.log_dir = '/var/log/mirror_manager/'
  config.admin_email = 'riseops@rise.ph'
  config.mirror_data_file = File.join(__dir__, '../../data/mirror_data.ini')
  config.database = File.join(__dir__, '../../db/mirror_prod.db')
  config.slack_webhook = ENV['SLACK_WEBHOOK']
end

mirror_db = Rise::MirrorManager.configuration.database
unless File.exist?(mirror_db)
  SQLite3::Database.open(mirror_db, results_as_hash: true) do |db|
    db.execute %{
      CREATE TABLE IF NOT EXISTS mirrors(
      mirror_id INTEGER NOT NULL PRIMARY KEY,
      name TEXT NOT NULL UNIQUE
  );}
    db.execute %{
      CREATE TABLE IF NOT EXISTS sync_info(
			sync_info_id INTEGER NOT NULL PRIMARY KEY,
			mirror_id INTEGER UNIQUE NOT NULL,
			sync_status TEXT,
			total_bandwidth TEXT,
			error TEXT,
			FOREIGN KEY (mirror_id) REFERENCES mirror (mirror_id)
			ON DELETE CASCADE ON UPDATE NO ACTION
  );}
  end
end
