require 'rise/mirror_manager/configuration'
require 'sqlite3'

puts 'Initializing . . .'

Rise::MirrorManager.configure do |config|
  config.log_dir = File.join(__dir__, '../../logs/')
  config.admin_email = 'riseops@rise.ph'
  config.mirror_data_file = File.join(__dir__, '../../spec/data/mirror_data.ini')
  config.database = File.join(__dir__, '../../db/mirror_test.db')
end

# Create /db/mirror_test.db
mirror_db = Rise::MirrorManager.configuration.database
File.delete(mirror_db) if File.exist?(mirror_db)
SQLite3::Database.open(mirror_db, results_as_hash: true) do |db|
  db.execute %{
      CREATE TABLE IF NOT EXISTS mirrors(
      mirror_id INTEGER NOT NULL PRIMARY KEY,
      name TEXT NOT NULL UNIQUE
  );}
  db.execute %{
      CREATE TABLE IF NOT EXISTS sync_info(
			sync_info_id INTEGER NOT NULL PRIMARY KEY,
			mirror_id INTEGER UNIQUE NOT NULL,
			sync_status TEXT,
			total_bandwidth TEXT,
			error TEXT,
			FOREIGN KEY (mirror_id) REFERENCES mirror (mirror_id)
			ON DELETE CASCADE ON UPDATE NO ACTION
  );}
  db.execute %{
    INSERT INTO mirrors(name) VALUES
    ('Ubuntu'),
    ('ArchLinux'),
    ('CentOS'),
    ('Tails'),
    ('RISE')
  }
end
