require_relative 'configuration'
require 'pony'
require 'slack/incoming/webhooks'

module Rise
  module MirrorManager
    # Module containing notification functionalities
    module Notification
      SLACK = Slack::Incoming::Webhooks.new Rise::MirrorManager.configuration.slack_webhook

      def send_email(msg)
        Pony.mail({
          :to => Rise::MirrorManager.configuration.admin_email,
          :from => "MirrorManager@#{Socket.gethostname}",
          :via => :smtp,
          :via_options  =>  {
            :address    =>  'aspmx.l.google.com',
            :port       =>  25,
            :domain     =>  Socket.gethostname
          },
          :subject      => "[#{Socket.gethostname}]MirrorManager Notification @ #{(Time.now).strftime("[%Y-%m-%d]%A, %H:%M")}",
          :body         => msg
        })
      end

      def send_slack_message(mirror_name:, error:, runtime:)
        attachment = {
          fallback: "#{mirror_name} has failed syncing @ #{runtime}. Error: #{error}",
          color: "#FF0000",
          "fields": [
            {
              "title": "#{mirror_name} Failed",
              "value": "#{error}"
            }
          ],
          "footer": "#{runtime}"
        }

        SLACK.post '', attachments: [attachment]
        puts 'hmmm'
        # https://hooks.slack.com/services/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
        # TODO: IMplement
      end
    end
  end
end
